REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM ~~~~ RESTORE DAMINION SERVER CATALOG (POSTGRESQL DATABASE) ~~~~
REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
CLS
ECHO OFF


REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM ~~~~ Init ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

CALL backup_config.bat
%~d0
CD %~dp0


REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM ~~~~ !Specify a path to your daminion server backup! ~~~~~~~~~~
REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SET DATABASE_DUMP="Backup\NetCatalog 02-17-2012 12-57-52.backup"
IF NOT EXIST %DATABASE_DUMP% GOTO DumpNotExist


REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM ~~~~ Backup Database before Restore ~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

CALL "%PGBIN%\pg_dump.exe" --format=custom --verbose --file=%DUMPPATH% 2>%LOGPATH%


REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM ~~~~ RESTORE ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SET ON_ERROR_STOP=1
REM CALL "%PGBIN%\psql" -c "ALTER DATABASE %PGDATABASE% RENAME TO %PGDATABASE%_Old"
REM CALL "%PGBIN%\psql" -c "CREATE DATABASE %PGDATABASE%_OLD WITH TEMPLATE "\"%PGDATABASE%"\""

CALL "%PGBIN%\createdb" %PGDATABASE%
CALL "%PGBIN%\pg_restore" -c -d %PGDATABASE% %DATABASE_DUMP%

REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM ~~~~ Finalizing ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

IF NOT %ERRORLEVEL%==0 GOTO Error
GOTO Successfull


:DumpNotExist
ECHO %DATETIME%: %DATABASE_DUMP% does not exist. >> restore.log
GOTO END

:Error
ECHO %DATETIME%: Error #%ERRORLEVEL%. Unable to restore %PGDATABASE% from %DATABASE_DUMP%. >> backup.log
GOTO End

:Successfull
ECHO %DATETIME%: %PGDATABASE% was successfully restored from %DATABASE_DUMP%. >> backup.log
GOTO End

:END
